package es.ua.jtech.struts.dao;

import java.sql.*;
import javax.sql.*;
import javax.naming.*;

/**
 * Sirve para obtener conexiones de la base de datos, usando un pool para hacerlo
 * eficiente
 * @author otto
 *
 */
public class FuenteDatos {
	private static DataSource ds = null;
	
	/**
	 * Obtiene una conexin de la base de datos
	 * @return la conexin
	 * @throws NamingException si hay algn problema con la configuracin.
	 * @throws SQLException si hay algn problema con la base de datos en s.
	 */
	public static Connection getConnection() throws NamingException, SQLException {
	   if (ds==null) {
		   Context contextoInicial =new InitialContext();
		   Context contextoEntorno = (Context) contextoInicial.lookup("java:comp/env");
		   ds = (DataSource) contextoEntorno.lookup("jdbc/ToDo");
	   }
	   return ds.getConnection();
	}

}